广东十一选五开奖 > 计算机网络 > PHP中Exception异常处理类的使用详解

原标题:PHP中Exception异常处理类的使用详解

浏览次数:62 时间:2019-10-03

  1、内置异常处理类。
  2、捕获并处理异常的示例。
  3、exception类的成员函数getmessage()。
  4、exception类的成员函数getfile()。
  5、exception类的成员函数getline()。
  6、显示警告或错误信息。
  7、自定义错误处理函数。

*/

 代码如下

 // 1、内置异常处理类。

<?php
    try {
        $a=10/0;
    }catch (Exception $e){
        echo "抛出异常";
    }
?>

 代码如下

以上代码,并不会输出“抛出异常”,而是输出了错误信息:Warning: Division by zero in......

 class exception
{
    protected $message = 'unknown exception';   // 异常信息
    protected $code = 0;                        // 用户自定义异常代码
    protected $file;                            // 发生异常的文件名
    protected $line;                            // 发生异常的代码行号

说明:try块中并没有抛出异常,而是按照系统默认的错误处理机制进行处理

    function __construct($message = null, $code = 0);

所以能不能捕获到异常,取决于有没有真正的抛出异常

    final function getmessage();                // 返回异常信息
    final function getcode();                   // 返回异常代码
    final function getfile();                   // 返回发生异常的文件名
    final function getline();                   // 返回发生异常的代码行号
    final function gettrace();                  // backtrace() 数组
    final function gettraceasstring();          // 已格成化成字符串的 gettrace() 信息

 

    function __tostring();                      // 可输出的字符串
}  

 代码如下

// 2、捕获并处理异常的示例。

<?php
class Exception
{
    protected $message = 'Unknown exception';   // 异常信息
    protected $code = 0;                        // 用户自定义异常代码
    protected $file;                            // 发生异常的文件名
    protected $line;                            // 发生异常的代码行号

 代码如下

    function __construct($message = null, $code = 0);

 try
{
    $error = '抛出异常信息,并且跳出try块<br/>';
    if(is_dir('./test'))
    {
        echo '检测到../ch16是一个目录';
        echo '<br/>';
        echo '可能继续做其他一些操作';
        echo '<br/>';
        echo '....';
        echo '<br/>';
    }
    else
    {
        throw new exception($error,12345);
    }
    echo '上面throw异常的话,这行代码不会执行,转而执行catch块<br/>';
}
catch(exception $e)
{
    echo '捕获异常: ' . $e->getmessage() . "<br/>错误代码:" . $e->getcode().'<br/>';    //显示$error和123456
    echo '<br/>';
}

    final function getMessage();                // 返回异常信息
    final function getCode();                   // 返回异常代码
    final function getFile();                   // 返回发生异常的文件名
    final function getLine();                   // 返回发生异常的代码行号
    final function getTrace();                  // backtrace() 数组
    final function getTraceAsString();          // 已格成化成字符串的 getTrace() 信息

echo '继续执行';

    /* 可重载的方法 */
    function __toString();                       // 可输出的字符串
}
?>

 

简单的使用如下:(通过异常,抛出错误信息)

 

 代码如下

 // 3、exception类的成员函数getmessage()。  

try {
    $error = 'my error!';
    throw new Exception($error)
} catch (Exception $e) {
    echo $e->getMessage();
}

 

我们可以扩展此类,方便我们的使用

 代码如下

 

$file = './test/readme.txt';

 代码如下

try
{
    if(is_dir($file))
    {
        echo '检测到目录';
    }
    else
    {
        //创建异常对象,错误信息将有exception类的成员函数getmessage()返回
        throw new exception('未找到该目录或文件');
    }
}
catch(exception $e)
{
    echo '捕获异常: ' . $e->getmessage();
    echo '<br/>===============================';
    echo '<br/>';
}

class MyException extends Exception
{
    // 重定义构造器使 message 变为必须被指定的属性
    public function __construct($message, $code = 0) {
        // 自定义的代码

echo '程序执行完毕';  

        // 确保所有变量都被正确赋值
        parent::__construct($message, $code);
    }

// 4、exception类的成员函数getfile()。  

    // 自定义字符串输出的样式
    public function __toString() {
        return __CLASS__ . ": [{$this->code}]: {$this->message}n";
    }

 代码如下

    public function customFunction() {
        echo "A Custom function for this type of exceptionn";
    }
}   

$file = './test/readme.txt';

异常处理的基本思想是代码在try代码被调用执行。如果try码块出现错误,我们可以执行一个抛出异常的处理。某些编程语言,如java,,在特定情况下将自动抛出异常。在php中,异常必须手动抛出。可以使用如下方式抛出一个异常:

try
{
    if(is_dir($file))
    {
        echo '检测到目录';
    }
    else
    {
        //创建异常对象,错误信息将有exception类的成员函数getmessage()返回
        throw new exception('未找到该目录或文件');
    }
}
catch(exception $e)
{
    echo '捕获异常: ' . $e->getmessage();
    echo '<br/><br/>';
    echo '错误所在文件:'. $e->getfile();
    echo '<br/>===============================';
    echo '<br/>';
}

 代码如下

echo '程序执行完毕';  

  Throw new Exception(‘message’,code);

// 5、exception类的成员函数getline()。

  Throw 关键字将触发异常处理机制,它是一个语言结构,而不是一个函数,但是必须给它传递一个值。它要求一个接受对象。在最简单的情况下,可以实例化一个内置的Exception类。

 代码如下

  最后,在try代码之后,必须至少给出一个catch代码块。可以将多个catch代码块与一个try代码块进行关联。如果每个catch代码块可以捕获一个不同类型的异常,可以使用多个catch代码块是有意义的。例如,如果想捕获Exception类的异常,代码如下

 $file = './test/readme.txt';

 

try
{
    if(is_dir($file))
    {
        echo '检测到目录';
    }
    else
    {
        //创建异常对象,错误信息将有exception类的成员函数getmessage()返回
        throw new exception('未找到该目录或文件');
    }
}
catch(exception $e)
{
    echo '捕获异常: ' . $e->getmessage();
    echo '<br/><br/>';
    echo '错误所在文件:'. $e->getfile();
    echo '<br/><br/>';
    echo '错误所在行号:'. $e->getline();
    echo '<br/>===============================';
    echo '<br/>';
}

 代码如下

echo '程序执行完毕';

Catch(Exception $e)

 // 6、显示警告或错误信息。

{

 代码如下

   //handing exception

 error_reporting(e_warning | e_error);    //显示警告和错误信息
echo $uvar;                        //这里产生注意信息,但不会显示出来
callfunc();                            //这里产生一个致命错误,并且会显示出来
 // 7、自定义错误处理函数。
 set_error_handler('myhandler');     //自定义错误处理函数

}

function myhandler($code, $msg, $file, $line)
{
    echo "<br/>";
    echo "程序 <b>$file</b> 执行过程中,在第 <b>$line</b> 行,产生一个错误。";
    echo "<br/>";
    echo "错误代码为:<b>$code</b>, 错误的原因是: <b>$msg</b>";
}

Catch代码捕获的对象就是导致异常并传递给throw语句的对象(被throw 语句抛出)。使用Exception 类的实例,是不错的选择。

echo $uvar;

Exception类提供了如下的内置方法:

?>

  Getcode()      —返回传递给构造函数的代码。

  GetMessage()    —返回传递给构造函数的消息。

  getFile()     —返回产生异常代码的文件的路径

  getLine()    —返回产生异常的代码所在的行。
注意:

当捕获到一个异常后,try()块里面的后续代码将不会继续执行,而是会尝试查找匹配的“catch”代码块
 当抛出一个异常后,如果不进行catch处理,则会报“Uncaught exception 'Exception'”错误

 代码如下

<?php
    function test($val){
        if ($val>100){
            throw new Exception("提示信息:您输入的值过大");
        }
    }
    test(111);
?>

  3.当一个异常抛出后,catch语句块可以进行处理也可以不处理

以下是我用户注册功能的部分代码

try{
     //check forms filled in
     if(!filled_out($_POST)){
         throw new Exception('你还没有填写表单,请回去填写');
     }
     //check email address not valid
     if(!check_email($email)){
        throw new Exception('邮件的格式不正确');
     }
     //检查密度的长度是否大于6
     if(strlen($passwd<6)){
         throw new Exception('密度的长度应该大于6');
     }
     //检查两次密码是否相等
     if($passwd!=$passwd1){
         throw new Exception('两次密码不一样,请重新输入');
     }
     //检查用户名的长度是否正确
     if(strlen($username)>16){
         throw new Exception('用户名的长度不符,请重新输入');
     }
  
 } catch(Exception $e){
     echo $e->getMessage(); //输出异常信息。
 }

 

php对异常的处理与java一样,用到的是try{}catch(){}

定义顶级异常处理器用到的函数是
set_exception_handler("My_exception");
这里的My_expection是开发者自定义的异常处理函数,既顶级异常处理器,只有当程序中没有函数来处理异常才有顶级异常处理器来处理异常,如果没有定义顶级异常处理器,则由系统默认的异常处理器来处理异常
举例说明:

 代码如下

<meta http-equiv="content-type" content="text/html;charset=utf-8" /><?php
    set_exception_handler("My_expection");
    function My_expection(){
        echo "这里是顶级异常处理器";
    }
    try{
        nohello("hello");
    }catch(Exception $e){
        throw $e;
    }
  function nohello($nohello){
          if($nohello == "hello"){
              throw new Exception("不能输入hello");
          }else{
            echo "输入成功";
        }
    }
?>

 

本文由广东十一选五开奖发布于计算机网络,转载请注明出处:PHP中Exception异常处理类的使用详解

关键词:

上一篇:PHP数据集构建JSON及新数组介绍

下一篇:ajax+php无刷新二级联动菜单的应用实例